F: meson.build
F: meson_options.txt
F: config/rte_config.h
+F: buildtools/binutils-avx512-check.sh
F: buildtools/call-sphinx-build.py
F: buildtools/gen-pmdinfo-cfile.sh
F: buildtools/list-dir-globs.py
--- /dev/null
+#! /bin/sh
+# SPDX-License-Identifier: BSD-3-Clause
+# Copyright(c) 2020 Intel Corporation
+
+AS=${AS:-as}
+OBJFILE=$(mktemp -t dpdk.binutils-check.XXXXXX.o)
+trap 'rm -f "$OBJFILE"' EXIT
+# from https://gcc.gnu.org/bugzilla/show_bug.cgi?id=90028
+GATHER_PARAMS='0x8(,%ymm1,1),%ymm0{%k2}'
+
+# assemble vpgather to file and similarly check
+echo "vpgatherqq $GATHER_PARAMS" | $AS --64 -o $OBJFILE -
+objdump -d --no-show-raw-insn $OBJFILE | grep -q $GATHER_PARAMS || {
+ echo "vpgatherqq displacement error with as"
+ exit 1
+}
# SPDX-License-Identifier: BSD-3-Clause
# Copyright(c) 2017-2019 Intel Corporation
-subdir('pmdinfogen')
-
pkgconf = find_program('pkg-config', 'pkgconf', required: false)
pmdinfo = find_program('gen-pmdinfo-cfile.sh')
list_dir_globs = find_program('list-dir-globs.py')
check_symbols = find_program('check-symbols.sh')
ldflags_ibverbs_static = find_program('options-ibverbs-static.sh')
+binutils_avx512_check = find_program('binutils-avx512-check.sh')
# set up map-to-win script using python, either built-in or external
python3 = import('python').find_installation(required: false)
# get binutils version for the workaround of Bug 97
if not is_windows
- ldver = run_command('ld', '-v').stdout().strip()
- if ldver.contains('2.30') and cc.has_argument('-mno-avx512f')
+ binutils_ok = run_command(binutils_avx512_check)
+ if binutils_ok.returncode() != 0 and cc.has_argument('-mno-avx512f')
machine_args += '-mno-avx512f'
- message('Binutils 2.30 detected, disabling AVX512 support as workaround for bug #97')
- endif
- if ldver.contains('2.31') and cc.has_argument('-mno-avx512f')
- machine_args += '-mno-avx512f'
- message('Binutils 2.31 detected, disabling AVX512 support as workaround for bug #249')
+ warning('Binutils error with AVX512 assembly, disabling AVX512 support')
endif
endif
'lib/librte_eal/@0@/include'.format(host_machine.system()),
'lib/librte_eal/@0@/include'.format(arch_subdir),
)
+
+# do configuration and get tool paths
+subdir('buildtools')
subdir('config')
# build libs and drivers
-subdir('buildtools')
+subdir('buildtools/pmdinfogen')
subdir('lib')
subdir('drivers')